# systemd
*This article is part of the bloat and vomit inducing series*

systemd (also known as soystemd) is a [bloated](bloat.md) and predatory init system for [Linux](linux.md) made by [Micro$oft](microsoft.md)
employee Lennart Poettering (then working for RedHat) as a mean of bringing the *Embrace, Extend and Extinguish* and update culture movements into Linux.

systemd is not only a PID 1 init, is an entire suit of bloat, which pointlessly replaces functionality that was already provided by standard
[Unix](unix.md) utilities, It also provides a binary logging format that's only viewable with `journalctl`, which adds additional problems
such that a file system corruption (or just file corruption) can lead to log files being unreadable, in contrast with the traditional practice of
using just plain text files for logging, which stay relatively readable after corruption.

On a systemd-infested system, `rm -rf /` not only will nuke your root filesystem; it can also [brick your motherboard](https://github.com/systemd/systemd/issues/2402)
(if using UEFI boot).

A notable backdoor (thwarted) attempt in 2024 on liblzma was facilitated by a completely redundant systemd dependency added by Debian maintainers to OpenSSH.
Had the backdoor attempt succeeded, it would have given full root access to millions of Linux servers.

## Distros without soystemd
- Artix Linux (basically Arch Linux without systemd)
- Gentoo
- Alpine Linux
- Void Linux
- Devuan (fork of Debian)
- Slackware
- Linux From Scratch
- OpenWRT
- GNU Guix
- ...

## See also
- [suckless view on systemd](https://suckless.org/sucks/systemd/)
- [Without Systemd](https://without-systemd.org/wiki/index_php/Main_Page/)
- [Laurent Bercot's (s6 creator) take on systemd](https://skarnet.org/software/systemd.html)
- [Broken by design: systemd](https://ewontfix.com/14/)

## Alternatives
- [s6](s6.md)
- runit
- OpenRC (from Gentoo)
- SysVinit
- BSD-style rc init systems
- [suckless sinit](https://core.suckless.org/sinit/)
- GNU Shepherd, init system and service manager written in (Guile) [Scheme](scheme.md), used
by the GNU Guix distro.
