# TCC (Tiny C Compiler)
[TCC](https://www.bellard.org/tcc/) is a [C](c.md) [compiler](compiler.md) written by Fabrice Bellard,
notable for having a simple implementation (< 40k LOC) and very fast compile times compared to more heavy duty
compilers such as GCC or Clang. Originally it only supported the x86 (and x86-64) architecture,
but ARM and RISC-V codegen have been implemented.

TCC is self-contained since it also implements its own linker, assembler and preprocessor.

Due to its simple implementation, TCC does not implement optimizations other than constant folding,
however it stays relevant as a compiler for fast debug builds and for bootstrapping purposes.

Currently development happens at <https://repo.or.cz/tinycc.git>.
