# Unix
Unix is a highly influential operating system created in 1969 in Bell Labs by Dennis Ritchie and Ken Thompson after they
stopped working in [Multics](multics.md), which got too [bloated](bloated), big and expensive, so Bell Labs pulled out of it. Latter on other
programmers that worked in Multics joined Unix. Nowadays the "Unix" name is used as a generic name to refer to the family
of Unix-like operating systems.

Unlike Multics, which was developed for a big and powerful mainframe for the time, Unix was developed initially in an PDP-7 that was lying around
as a way to run a video game written by Thompson, *Space Travel* which was originally written for the GE 635 mainframe running Multics .
Fortunately in an excellent timing, his wife went on vacation leaving him a month free (Turns out he only needed 2 weeks). Later they
convinced management to get a more powerful PDP-11 in which Unix development continued.

Unix also spawned the [Unix philosophy](unix_philosophy.md) which in basic terms states that a program should do a single thing
and do it well, promoting modularity (by using [pipes](pipe.md) as [IPC](ipc.md)) in contrast to monolithic programs found in other
OSes in the time (like Multics) and also in "modern" OSes like Windows, favouring the use of text over binary data and following
the [KISS](kiss.md) design principle.

Unix was exclusively written in PDP-11 assembly up version 4 when [C](c.md) was created and the OS and its tools began to be rewritten in C.

In 1979 the seventh edition of Research Unix was released, being the first edition to be fully portable. (last good research Unix version?)
[BSD](bsd.md) was forked from this version.

A PDP-11 emulator running Unix Version 6 online can be found here: <https://pdp11.aiju.de/>.

## Some Unix-like operating systems
- [BSDs](bsd.md)
- [Linux](linux.md)
- [Minix](minix.md): a [microkernel](microkernel.md)-based OS by Andrew Tannenbaum
- [Hurd](hurd.md): GNU's kernel, microkernel design based on Mach.
- [Plan 9](plan9.md): successor of Research Unix.
- MacOS: Apple's OS, built on stolen code from FreeBSD, proprietary.
- ...
